      subroutine stran(ein,ang,eout)
c  for plane strain ein (expressed as a vector e11, e22, e12),
c  computes the strain (expressed similarly) for a coordinate
c  system rotated counterclockwise by an angle ang (in degrees),
c  the result being returned in eout
c    $$$$$calls only system routines
      dimension ein(3),eout(3)
      data dr/.0174533/
      a = dr*ang
      c = cos(dr*ang)
      s = sin(dr*ang)
      eout(1) = ein(1)*c*c + ein(2)*s*s + 2.*ein(3)*c*s
      eout(2) = ein(1)*s*s + ein(2)*c*c - 2.*ein(3)*c*s
      eout(3) = (-ein(1)+ein(2))*c*s + ein(3)*(c**2 - s**2)
      return
      end
      subroutine van(vin,ang,vout)
c  for a plane vector vin computes the vector for a coordinate
c  system rotated counterclockwise by an angle ang (in degrees),
c  the result being returned in vout
c    $$$$$calls only system routines
      dimension vin(2),vout(2)
      data dr/.0174533/
      a = dr*ang
      c = cos(dr*ang)
      s = sin(dr*ang)
      vout(1) = vin(1)*c + vin(2)*s
      vout(2) = -vin(1)*s + vin(2)*c
      return
      end
