c  program stpresp
c   for a file of positions of given rectangular dislocations, writes out
c a file giving c response on the surface of a half-space for multiple
c observations at a single location
c
c   $$$calls segget,stpsub,topo,sdefor,stran,van
c
c
      character*1 iobs,not,locat,itype
      dimension azimu(30),scl(30),resp(30),err(30),olat(30),olong(30),
     1    itype(30)
      character*60 filnam
      dimension e1(3),t1(2),d1(3),e2(3),t2(3),d2(3),x(20)
      common/eqparm/slat,slong,depth,str,dip,rake,al,aw,slip,locat
      common/elascn/pr
      data np/20/,dr/0.0174533/
      pr = 0.25
      nobs = 0
 3    write(6,100)
 100  format(' N lat and E long of observation point; ',$)
      rlat = ffin(1,not)
      rlong = ffin(1,not)
 5    write(6,102)
 102  format(' Azimuth (if needed) and type of datum (h for help); ',$)
      dir = ffin(1,iobs)
      if(dir.ne.666) dir = 180-dir
      if(iobs.eq.'p') go to 3
      if(iobs.eq.'x') go to 7
      if(iobs.eq.'h') write(6,104)
 104  format(' Types of data allowed are:',/,5x,
     1 '   z - vertical displacement',/,5x,
     2 'nnnd - horizontal displacement at azimuth nnn',/,5x,
     3 '       (azimuth of 666 means max displacement)',/,5x,
     4 'nnnl - extension at azimuth nnn',/,5x,
     5 '       (azimuth of 666 means max extension)',/,5x,
     6 '   v - volume strain (for poisson''s ratio 0.25)',/,5x,
     7 'nnns - shear strain at azimuth nnn',/,5x,
     8 'nnnt - tilt at azimuth nnn',/,5x,
     9 '       (azimuth of 666 means max tilt)',/,5x,
     1 '   r - rms extension ',/,5x,
     1 '   b - rotation (change in azimuth)',/,5x,
     2 '   p - new place of observation',/,5x,
     3 '   x - continue')
      if(iobs.eq.'h') go to 5
      nobs=nobs+1
      if(nobs.gt.30) go to 7
      itype(nobs)=iobs
      azimu(nobs)=dir
      scl(nobs) =1.e9
      if(iobs.eq.'z'.or.iobs.eq.'d') scl(nobs) = 1000
      olat(nobs) = rlat
      olong(nobs) = rlong
      go to 5
c
c    Get fault parameters
c
 7    call segget(nseg)
      write(6,108)
 108  format(' Name of output file;; ',$)
      read(5,*) filnam
      lu = 1
      open(lu,file=filnam,status='unknown')
      do j=1,nobs
         write(1,110) j,itype(j),azimu(j),scl(j),olat(j),olong(j)
 110     format('Obs ',i2,' type ',a1,' az ',f6.1,' scl ',e8.2,
     1          ' at ',f8.4,f10.4)
      enddo
c
c loop over fault segments, and for each one over obs
c
      do l=1,nseg
c calls to segget here put another segment into eqparam
        call segget(nseg)
        do j=1,nobs
          call stpsub(olat(j),olong(j),e2,t2,d2)
          call strinv(e2,erms,exmax,efx,shmax)
          if(itype(j).eq.'z') resp(j) = d2(3)
          if(itype(j).eq.'r') resp(j) = erms
          if(itype(j).eq.'v') resp(j) = .6667*(e2(1)+e2(2))
          if(itype(j).eq.'b') resp(j) = t2(3)
          if(azimu(j).ne.666) then
             call van(d2,azimu(j),d1)
             call van(t2,azimu(j),t1)
             call stran(e2,azimu(j),e1)
             if(itype(j).eq.'d') resp(j) = d1(1)
             if(itype(j).eq.'t') resp(j) = t1(1)
             if(itype(j).eq.'l') resp(j) = e1(1)
             if(itype(j).eq.'s') resp(j) = e1(3)
          else
             if(itype(j).eq.'d') resp(j) = sqrt(d2(1)**2 + d2(2)**2)
             if(itype(j).eq.'t') resp(j) = sqrt(t2(1)**2 + t2(2)**2)
             if(itype(j).eq.'l') resp(j) = exmax
             if(itype(j).eq.'s') resp(j) = shmax
          endif
        enddo
        write(1,144) slat,slong,depth,(resp(j),j=1,nobs)
 144    format('Seg ',f7.4,f10.4,f7.2,' res ',10g13.5)
      enddo
      stop
      end
