c  program strnstp
c   for a given source (of faulting) finds the response at a given point
c on the surface of a half-space
c
c   $$$calls stpsub,seggest,topo,fdefor,stran,van
c
c
      character*1 iobs,not
      character*20 filnam
      dimension e1(3),t1(3),d1(3),e2(3),t2(3),d2(3)
      dimension e2t(3),t2t(3),d2t(3)
      write(6,100)
 100  format(' North lat and East long of observation point; ',$)
      rlat = ffin(1,not)
      rlong = ffin(1,not)
c get fault information
      call segget(nsegs)
 3    write(6,104)
 104  format(' Azimuth (if needed) and type of datum (h for help) ; ',$)
      dir = ffin(1,iobs)
      if(dir.ne.666) dir = 180-dir
      if(iobs.eq.'x') stop
      if(iobs.eq.'h') write(6,106)
 106  format(' Types of data allowed are:',/,5x,
     1 '   z - vertical displacement',/,5x,
     2 'nnnd - horizontal displacement at azimuth nnn',/,5x,
     3 '       (azimuth of 666 means max displacement)',/,5x,
     4 'nnnl - extension at azimuth nnn',/,5x,
     5 '       (azimuth of 666 means max extension)',/,5x,
     6 '   v - volume strain (for poisson''s ratio 0.25)',/,5x,
     7 'nnns - shear strain at azimuth nnn',/,5x,
     8 'nnnt - tilt at azimuth nnn',/,5x,
     9 '       (azimuth of 666 means max tilt)',/,5x,
     1 '   r - rms extension ',/,5x,
     1 '   b - rotation (change in azimuth)',/,5x,
     1 '   x - exit from program')
      if(iobs.eq.'h') go to 3
      scale = 1.
      if(iobs.eq.'z'.or.iobs.eq.'d') scale = 1
c set parameters to zero, in preparation for summing over fault segments
      do l=1,3
        d2(l)=0
        e2(l)=0
        t2(l)=0
      enddo
c first call to segget gets parameters, second steps through fault segments,
c with a loop to the beginning (so we can call this routine nseg times for
c each point)
      do k=1,nsegs
        call segget(nsegs)
        call stpsub(rlat,rlong,e2t,t2t,d2t)
        do l=1,3
          d2(l)=d2(l)+d2t(l)
          e2(l)=e2(l)+e2t(l)
          t2(l)=t2(l)+t2t(l)
        enddo
      enddo
      call strinv(e2,erms,exmax,efx,shmax)
      if(iobs.eq.'z') x = d2(3)
      if(iobs.eq.'r') x = erms
      if(iobs.eq.'v') x = .6667*(e2(1)+e2(2))
      if(iobs.eq.'b') x = t2(3)
      if(dir.ne.666) then
         call van(d2,dir,d1)
         call van(t2,dir,t1)
         call stran(e2,dir,e1)
         if(iobs.eq.'d') x = d1(1)
         if(iobs.eq.'t') x = t1(1)
         if(iobs.eq.'l') x = e1(1)
         if(iobs.eq.'s') x = e1(3)
      else
         if(iobs.eq.'d') x = sqrt(d2(1)**2 + d2(2)**2)
         if(iobs.eq.'t') x = sqrt(t2(1)**2 + t2(2)**2)
         if(iobs.eq.'l') x = exmax
         if(iobs.eq.'s') x = shmax
      endif
      x=x*scale
      if(iobs.eq.'z'.or.iobs.eq.'d') then
        write(6,120) x
 120    format(' Displacement is ',f8.2,' mm')
      endif
      if(iobs.eq.'t') then
        write(6,122) x
 122    format(' Tilt is ',f8.2,' nanoradians ')
      endif
      if(iobs.eq.'l'.or.iobs.eq.'r'.or.iobs.eq.'v'.or.iobs.eq.'s') then
        write(6,124) x
 124    format(' Strain is ',f8.2,' nanostrain ')
      endif
      go to 3
      end
